Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Problems/CountOdds.cs	(revision 14513)
@@ -1,145 +1,142 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
+﻿namespace HeuristicLab.BenchmarkSuite.Problems
+{
+  using System.Collections.Generic;
+  using System.Linq;
 
-namespace HeuristicLab.BenchmarkSuite.Problems
-{
-    public class CountOdds : BenchmarkSuiteDataDescritpor<List<int>>
+  public class CountOdds : BenchmarkSuiteDataDescritpor<List<int>>
+  {
+    public const int MaxOdd = 999;
+
+    public const int MaxEven = 1000;
+
+    public const int MaxRandom = 1000;
+
+    public const int MinRandom = 1000;
+
+    public const int MaxVectorLength = 50;
+
+    public override string Description
     {
-        public const int MaxOdd = 999;
-        public const int MaxEven = 1000;
-        public const int MaxRandom = 1000;
-        public const int MinRandom = 1000;
-        public const int MaxVectorLength = 50;
+      get
+      {
+        return string.Empty;
+      }
+    }
 
-        public override string Description { get { return String.Empty; } }
+    public override string Name
+    {
+      get
+      {
+        return "Count Odds";
+      }
+    }
 
-        public override string Name { get { return "Count Odds"; } }
+    protected override IEnumerable<Example> GenerateExamples(IEnumerable<List<int>> inputData)
+    {
+      foreach (var input in inputData)
+        yield return
+          new Example
+            {
+              Input = string.Format("[{0}]", string.Join(", ", input)),
+              Output = input.Count(x => x % 2 == 1).ToString()
+            };
+    }
 
-        protected override IEnumerable<Example> GenerateExamples(IEnumerable<List<int>> inputData)
-        {
-            foreach (var input in inputData)
-            {
-                yield return new Example()
-                {
-                    Input = string.Format("[{0}]", string.Join(", ", input)),
-                    Output = input.Count(x => x % 2 == 1).ToString()
-                };
-            }
-        }
+    protected override IEnumerable<List<int>> GenerateTest()
+    {
+      foreach (var list in this.GetHardcodedTrainingSamples()) yield return list;
 
-        protected override IEnumerable<List<int>> GenerateTest()
-        {
-            foreach (var list in GetHardcodedTrainingSamples())
-                yield return list;
+      foreach (var list in this.GetAllOdd(100)) yield return list;
 
-            foreach (var list in GetAllOdd(n: 100))
-                yield return list;
+      foreach (var list in this.GetAllEven(100)) yield return list;
 
-            foreach (var list in GetAllEven(n: 100))
-                yield return list;
+      foreach (var list in this.GetRandom(1800)) yield return list;
+    }
 
-            foreach (var list in GetRandom(n: 1800))
-                yield return list;
-        }
+    protected override IEnumerable<List<int>> GenerateTraining()
+    {
+      foreach (var list in this.GetHardcodedTrainingSamples()) yield return list;
 
-        protected override IEnumerable<List<int>> GenerateTraining()
-        {
-            foreach (var list in GetHardcodedTrainingSamples())
-                yield return list;
+      foreach (var list in this.GetAllOdd(9)) yield return list;
 
-            foreach (var list in GetAllOdd(n: 9))
-                yield return list;
+      foreach (var list in this.GetAllEven(9)) yield return list;
 
-            foreach (var list in GetAllEven(n: 9))
-                yield return list;
+      foreach (var list in this.GetRandom(150)) yield return list;
+    }
 
-            foreach (var list in GetRandom(n: 150))
-                yield return list;
-        }
+    private IEnumerable<List<int>> GetAllOdd(int n)
+    {
+      for (var i = 0; i < n; i++)
+      {
+        var length = rand.Next(0, MaxVectorLength);
+        var vector = new List<int>(length);
 
-        private IEnumerable<List<int>> GetAllOdd(int n)
-        {
-            for (var i = 0; i < n; i++)
-            {
-                var length = rand.Next(0, MaxVectorLength);
-                var vector = new List<int>(length);
+        for (var j = 0; j < length; j++) vector.Add(rand.Next(0, MaxOdd) * 2 - MaxOdd);
 
-                for (var j = 0; j < length; j++)
-                {
-                    vector.Add(rand.Next(0, MaxOdd) * 2 - MaxOdd);
-                }
+        yield return vector;
+      }
+    }
 
-                yield return vector;
-            }
-        }
+    private IEnumerable<List<int>> GetAllEven(int n)
+    {
+      for (var i = 0; i < n; i++)
+      {
+        var length = rand.Next(0, MaxVectorLength);
+        var vector = new List<int>(length);
 
-        private IEnumerable<List<int>> GetAllEven(int n)
-        {
-            for (var i = 0; i < n; i++)
-            {
-                var length = rand.Next(0, MaxVectorLength);
-                var vector = new List<int>(length);
+        for (var j = 0; j < length; j++) vector.Add(rand.Next(0, MaxEven) * 2 - MaxEven);
 
-                for (var j = 0; j < length; j++)
-                {
-                    vector.Add(rand.Next(0, MaxEven) * 2 - MaxEven);
-                }
+        yield return vector;
+      }
+    }
 
-                yield return vector;
-            }
-        }
+    private IEnumerable<List<int>> GetRandom(int n)
+    {
+      for (var i = 0; i < n; i++)
+      {
+        var length = rand.Next(0, MaxVectorLength);
+        var vector = new List<int>(length);
 
-        private IEnumerable<List<int>> GetRandom(int n)
-        {
-            for (var i = 0; i < n; i++)
-            {
-                var length = rand.Next(0, MaxVectorLength);
-                var vector = new List<int>(length);
+        for (var j = 0; j < length; j++) vector.Add(rand.Next(MinRandom, MaxRandom));
 
-                for (var j = 0; j < length; j++)
-                {
-                    vector.Add(rand.Next(MinRandom, MaxRandom));
-                }
+        yield return vector;
+      }
+    }
 
-                yield return vector;
-            }
-        }
-
-        private IEnumerable<List<int>> GetHardcodedTrainingSamples()
-        {
-            yield return new List<int>() { };
-            yield return new List<int>() { -10 };
-            yield return new List<int>() { -9 };
-            yield return new List<int>() { -8 };
-            yield return new List<int>() { -7 };
-            yield return new List<int>() { -6 };
-            yield return new List<int>() { -5 };
-            yield return new List<int>() { -4 };
-            yield return new List<int>() { -3 };
-            yield return new List<int>() { -2 };
-            yield return new List<int>() { -1 };
-            yield return new List<int>() { -0 };
-            yield return new List<int>() { 1 };
-            yield return new List<int>() { 2 };
-            yield return new List<int>() { 3 };
-            yield return new List<int>() { 4 };
-            yield return new List<int>() { 5 };
-            yield return new List<int>() { 6 };
-            yield return new List<int>() { 7 };
-            yield return new List<int>() { 8 };
-            yield return new List<int>() { 9 };
-            yield return new List<int>() { 10 };
-            yield return new List<int>() { -947 };
-            yield return new List<int>() { -450 };
-            yield return new List<int>() { 303 };
-            yield return new List<int>() { 886 };
-            yield return new List<int>() { 0, 0 };
-            yield return new List<int>() { 0, 1 };
-            yield return new List<int>() { 7, 1 };
-            yield return new List<int>() { -9, -1 };
-            yield return new List<int>() { -11, 40 };
-            yield return new List<int>() { 944, 77 };
-        }
+    private IEnumerable<List<int>> GetHardcodedTrainingSamples()
+    {
+      yield return new List<int>();
+      yield return new List<int> { -10 };
+      yield return new List<int> { -9 };
+      yield return new List<int> { -8 };
+      yield return new List<int> { -7 };
+      yield return new List<int> { -6 };
+      yield return new List<int> { -5 };
+      yield return new List<int> { -4 };
+      yield return new List<int> { -3 };
+      yield return new List<int> { -2 };
+      yield return new List<int> { -1 };
+      yield return new List<int> { -0 };
+      yield return new List<int> { 1 };
+      yield return new List<int> { 2 };
+      yield return new List<int> { 3 };
+      yield return new List<int> { 4 };
+      yield return new List<int> { 5 };
+      yield return new List<int> { 6 };
+      yield return new List<int> { 7 };
+      yield return new List<int> { 8 };
+      yield return new List<int> { 9 };
+      yield return new List<int> { 10 };
+      yield return new List<int> { -947 };
+      yield return new List<int> { -450 };
+      yield return new List<int> { 303 };
+      yield return new List<int> { 886 };
+      yield return new List<int> { 0, 0 };
+      yield return new List<int> { 0, 1 };
+      yield return new List<int> { 7, 1 };
+      yield return new List<int> { -9, -1 };
+      yield return new List<int> { -11, 40 };
+      yield return new List<int> { 944, 77 };
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Properties/AssemblyInfo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Properties/AssemblyInfo.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.BenchmarkSuite/Properties/AssemblyInfo.cs	(revision 14513)
@@ -1,4 +1,3 @@
 ﻿using System.Reflection;
-using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
 
@@ -6,4 +5,5 @@
 // set of attributes. Change these attribute values to modify the information
 // associated with an assembly.
+
 [assembly: AssemblyTitle("HeuristicLab.BenchmarkSuite")]
 [assembly: AssemblyDescription("")]
@@ -18,7 +18,9 @@
 // to COM components.  If you need to access a type in this assembly from 
 // COM, set the ComVisible attribute to true on that type.
+
 [assembly: ComVisible(false)]
 
 // The following GUID is for the ID of the typelib if this project is exposed to COM
+
 [assembly: Guid("22b5c087-cfc7-4d40-86c6-32fcf2ca921e")]
 
@@ -33,4 +35,5 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
+
 [assembly: AssemblyVersion("1.0.0.0")]
 [assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.PushGP.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.PushGP.csproj	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.PushGP.csproj	(revision 14513)
@@ -0,0 +1,97 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.PushGP</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.PushGP</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <LangVersion>5</LangVersion>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.IntegerVectorEncoding-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.IntegerVectorEncoding-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Optimization-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="Plugin.cs" />
+    <Compile Include="ProgramSynthesis\PushProblem.cs" />
+    <Compile Include="ProgramSynthesis\PushEvalutator.cs" />
+    <Compile Include="ProgramSynthesis\PushProgram.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Algorithms.PushGP\HeuristicLab.Algorithms.PushGP.csproj">
+      <Project>{368d1303-470c-4f31-91f2-0fad379daa45}</Project>
+      <Name>HeuristicLab.Algorithms.PushGP</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup />
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PostBuildEvent>"T:\BTSync\projects\svn\hl\trunk\sources\bin\HeuristicLab 3.3.exe"</PostBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.PushGP.csproj.user
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.PushGP.csproj.user	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.PushGP.csproj.user	(revision 14513)
@@ -0,0 +1,6 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <ProjectView>ShowAllFiles</ProjectView>
+  </PropertyGroup>
+</Project>
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Plugin.cs	(revision 14513)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Patrik Kimmeswegner
+ */
+
+#endregion
+
+namespace HeuristicLab.Problems.ProgramSynthesis.PushGP {
+  using HeuristicLab.PluginInfrastructure;
+
+  [Plugin("HeuristicLab.Problems.ProgramSynthesis.PushGP", "1.0")]
+  [PluginFile("HeuristicLab.Problems.ProgramSynthesis.PushGP.dll", PluginFileType.Assembly)]
+  [PluginFile("HeuristicLab.Algorithms.PushGP.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Random", "3.3")]
+  public class PushGpPlugin : PluginBase {
+
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushEvalutator.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushEvalutator.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushEvalutator.cs	(revision 14513)
@@ -0,0 +1,12 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
+
+  public class PushEvalutator {
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushProblem.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushProblem.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushProblem.cs	(revision 14513)
@@ -0,0 +1,46 @@
+﻿using System;
+
+namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+  [StorableClass]
+  [Creatable(CreatableAttribute.Categories.GeneticProgrammingProblems, Priority = 180)]
+  [Item("Push GP Problem", "")]
+  public class PushProblem : SymbolicExpressionTreeProblem {
+
+    private readonly PushGpInterpreterPool pool = new PushGpInterpreterPool(new Configuration());
+
+    // persistence
+    [StorableConstructor]
+    protected PushProblem(bool deserializing) : base(deserializing) { }
+
+    // cloning
+    protected PushProblem(PushProblem original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    protected PushProblem() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      throw new NotImplementedException();
+    }
+
+    public Configuration Configuration { get { return this.pool.Configuration; } }
+
+    public override bool Maximization { get { return false; } }
+
+    public override double Evaluate(ISymbolicExpressionTree tree, IRandom random) {
+      var program = tree as PushProgram;
+
+      using (var interpreter = this.pool.GetInstance()) {
+        interpreter.Interpret(program);
+      }
+
+      return 0d;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushProgram.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushProgram.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/ProgramSynthesis/PushProgram.cs	(revision 14513)
@@ -0,0 +1,58 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Problems.PushGP.ProgramSynthesis {
+  using System.Drawing;
+
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Common;
+  using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+
+  public class PushProgram : ExecExpandExpression, ISymbolicExpressionTree {
+    public PushProgram(Expression[] state)
+      : base(state) {
+    }
+
+    public PushProgram(ExecExpandExpression origin)
+      : base(origin) {
+    }
+
+    public object Clone() {
+      throw new NotImplementedException();
+    }
+
+    public IDeepCloneable Clone(Cloner cloner) {
+      throw new NotImplementedException();
+    }
+
+    public string ItemName { get; private set; }
+
+    public string ItemDescription { get; private set; }
+
+    public Version ItemVersion { get; private set; }
+
+    public Image ItemImage { get; private set; }
+
+    public event EventHandler ItemImageChanged;
+
+    public event EventHandler ToStringChanged;
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesBreadth() {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPrefix() {
+      throw new NotImplementedException();
+    }
+
+    public IEnumerable<ISymbolicExpressionTreeNode> IterateNodesPostfix() {
+      throw new NotImplementedException();
+    }
+
+    public ISymbolicExpressionTreeNode Root { get; set; }
+
+    public int Length { get { return this.State.Length; } }
+
+    public new int Depth { get { return base.Depth; } }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Properties/AssemblyInfo.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Properties/AssemblyInfo.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Problems.ProgramSynthesis/Properties/AssemblyInfo.cs	(revision 14513)
@@ -0,0 +1,36 @@
+﻿using System.Reflection;
+using System.Runtime.CompilerServices;
+using System.Runtime.InteropServices;
+
+// General Information about an assembly is controlled through the following 
+// set of attributes. Change these attribute values to modify the information
+// associated with an assembly.
+[assembly: AssemblyTitle("HeuristicLab.Problems.ProgramSynthesis.PushGP")]
+[assembly: AssemblyDescription("")]
+[assembly: AssemblyConfiguration("")]
+[assembly: AssemblyCompany("")]
+[assembly: AssemblyProduct("HeuristicLab.Problems.ProgramSynthesis.PushGP")]
+[assembly: AssemblyCopyright("Copyright ©  2016")]
+[assembly: AssemblyTrademark("")]
+[assembly: AssemblyCulture("")]
+
+// Setting ComVisible to false makes the types in this assembly not visible 
+// to COM components.  If you need to access a type in this assembly from 
+// COM, set the ComVisible attribute to true on that type.
+[assembly: ComVisible(false)]
+
+// The following GUID is for the ID of the typelib if this project is exposed to COM
+[assembly: Guid("5c93448c-47e3-4c3f-b1d0-ee62a48c3204")]
+
+// Version information for an assembly consists of the following four values:
+//
+//      Major Version
+//      Minor Version 
+//      Build Number
+//      Revision
+//
+// You can specify all the values or you can default the Build and Revision Numbers 
+// by using the '*' as shown below:
+// [assembly: AssemblyVersion("1.0.*")]
+[assembly: AssemblyVersion("1.0.0.0")]
+[assembly: AssemblyFileVersion("1.0.0.0")]
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Example.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Example.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/Example.cs	(revision 14513)
@@ -1,8 +1,7 @@
-﻿namespace HeuristicLab.Tests.Benchmark
-{
-    public class Example<Tin, Tout>
-    {
-        public Tin Input { get; set; }
-        public Tout Output { get; set; }
-    }
+﻿namespace HeuristicLab.Tests.Benchmark {
+  public class Example<Tin, Tout> {
+    public Tin Input { get; set; }
+
+    public Tout Output { get; set; }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ExampleConverter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ExampleConverter.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Benchmark/ExampleConverter.cs	(revision 14513)
@@ -1,35 +1,28 @@
-﻿using System.Linq;
+﻿namespace HeuristicLab.Tests.Benchmark
+{
+  using System.Linq;
 
-namespace HeuristicLab.Tests.Benchmark
-{
-    public static class ExampleConverter
+  public static class ExampleConverter
+  {
+    private const char ArrayValueSeparator = ' ';
+
+    private static readonly char[] arraySymbolTrim = { '[', ']' };
+
+    public static long Integer(string str)
     {
-        private const char ArrayValueSeparator = ' ';
+      return long.Parse(str);
+    }
 
-        private static readonly char[] arraySymbolTrim = new[] { '[', ']' };
+    public static long[] Integers(string str)
+    {
+      var values =
+        str.Trim(arraySymbolTrim).Split(ArrayValueSeparator).Where(s => !string.IsNullOrWhiteSpace(s)).ToList();
 
+      var result = new long[values.Count];
 
-        public static long Integer(string str)
-        {
-            return long.Parse(str);
-        }
+      for (var i = 0; i < result.Length; i++) result[i] = Integer(values[i]);
 
-        public static long[] Integers(string str)
-        {
-            var values = str
-                .Trim(arraySymbolTrim)
-                .Split(ArrayValueSeparator)
-                .Where(s => !string.IsNullOrWhiteSpace(s))
-                .ToList();
-
-            var result = new long[values.Count];
-
-            for (var i = 0; i < result.Length; i++)
-            {
-                result[i] = Integer(values[i]);
-            }
-
-            return result;
-        }
+      return result;
     }
+  }
 }
